﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MathParser
{
    public enum AutomatenZustand
    {
        Fehler,
        Laufend,
        Ende
    }
    public class Automat
    {
        public Automat(Zustand allZustaende)
        {
            aktuellerZustand = allZustaende;
            startZustand = aktuellerZustand;
            _token = string.Empty;
        }
        private Zustand aktuellerZustand;
        private Zustand startZustand;
        public AutomatenZustand NaechsterZustand(char pChar)
        {
            Zustand lZustand = null;
            foreach (var item in aktuellerZustand.NaechsteZustaende)
            {
                foreach (var elem in item.Bedingungen)
                {
                    if (pChar == elem)
                    {
                        _token += pChar;
                        lZustand = item;
                        break;
                    }
                }
            }
            if (lZustand == null)
            {
                bool lEnde = aktuellerZustand.Ende;
                aktuellerZustand = startZustand;
                if (lEnde)
                {
                    return AutomatenZustand.Ende;
                }
                else
                {
                    _token += pChar;
                    return AutomatenZustand.Fehler;
                }
            }
            else
                aktuellerZustand = lZustand;
            return AutomatenZustand.Laufend;
        }
        private string _token;
        public override string ToString()
        {
            string lInput = _token;
            _token = string.Empty;
            return lInput;
        }
    }
    public class Zustand
    {
        public Zustand(bool pEnde, char[] pItem, params Zustand[] pZustand)
        {
            this.NaechsteZustaende = pZustand.ToList();
            this.Ende = pEnde;
            this.Bedingungen = pItem;
        }
        public Zustand(bool pEnde, char[] pItem)
        {
            this.Ende = pEnde;
            this.Bedingungen = pItem;
            this.NaechsteZustaende = new List<Zustand>();
        }
        public char[] Bedingungen { get; private set; }
        public List<Zustand> NaechsteZustaende { get; set; }
        public bool Ende { get; private set; }
    }
}
