﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MathParser
{
    public static class Function
    {
        static Function()
        {
            functionParams = new Dictionary<string, Func<double[], double>>();
        }
        public static void AddFunction(string pName, int pParams, Func<double[], double> pFunc)
        {
            if (!functionParams.ContainsKey(pName))
               functionParams.Add(pName, (pValue) =>
            {
                if (pValue[0] == pParams)
                    return pFunc.Invoke(pValue.Skip(1).ToArray());
                throw new ArgumentException("Anzahl der Argumente für die Funktion " + pName + " ist ungültig " + "(" + pParams + " erwartet und " + pValue[0] + " übergeben)");
            });
        }
        public static bool Exists(string pFunc)
        {
            pFunc = pFunc.ToLower();
            return (functionParams.ContainsKey(pFunc));
        }
        private static Dictionary<string, Func<double[], double>> functionParams;
        public static double Execute(string pName, params double[] pParams)
        {
            pName = pName.ToLower();
            if (!functionParams.ContainsKey(pName))
                throw new ArgumentException("Funktion " + pName + " ist nicht bekannt");
            return functionParams[pName].Invoke(new double[] { pParams.Length }.Concat(pParams).ToArray());
        }
    }
}
