﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MathParser
{

    public class Token
    {
        public Token(string pValue, Type pType)
        {
            this.Value = pValue;
            this.TokenType = pType;
        }
        public string Value { get; private set; }
        public Type TokenType { get; private set; }
        public override string ToString()
        {
            return Enum.GetName(typeof(Type), TokenType).ToLower();
        }
    }
    public enum Type
    {
        [Description(4, 2, "+")]
        ADD,
        [Description(4, 2, "-")]
        SUB,
        [Description(5, 2, "*")]
        MUL,
        [Description(5, 2, "/")]
        DIV,
        [Description(5, 2, "\\")]
        INTDIV,
        [Description(5, 2, "%")]
        MODULO,
        [Description(6, 1, "!")]
        FAKULTAET,
        [Description(0, 0, ",")]
        NEXTPARAM,
        [Description(0, 0, "(", "[")]
        BROPEN,
        [Description(0, 0, ")", "]")]
        BRCLOSE,
        [Description(2, 2, "=", ":")]
        ASSIGN,
        [Description(3, 2, "^")]
        XOR,
        [Description(3, 2, "&")]
        AND,
        [Description(3, 2, "|")]
        OR,
        [Description(6, 1, "~")]
        NEG,
        [Description(6, 2, ">")]
        HIGHER,
        [Description(6, 2, "<")]
        LESS,
        [Description(1, 2, "?")]
        CONDITION,
        [Description(1, 2, "§")]
        ELSECONDITION,
        [Description(1, 2, "$")]
        UNTIL,
        [Description(1, 2, "#")]
        FOR,
        INTNUM,
        DECNUM,
        ID,
        FUNC,
        EOF
    }
}
